local currentTime = 0
local flooding = false
local targetIndex

local targets = {
    { time =   0, height = 124.143 },
    { time =  18, height = 138     },
    { time =  25, height = 142     },
    { time =  27, height = 142.5   },
    { time =  34, height = 144.5   },
    { time =  39, height = 146     },
    { time =  67, height = 157     },
    { time =  73, height = 157.5   },
    { time =  79, height = 179     },
    { time =  81, height = 181     },
    { time =  90, height = 190     },
    { time = 114, height = 242     },
    { time = 120, height = 247     },
    { time = 128, height = 260     },
    { time = 131, height = 263     },
    { time = 136, height = 277     },
    { time = 138, height = 283     },
    { time = 140, height = 284     }
}

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		TorqueScript.eval([[
			Ocean.hidden = "1";
			Ocean.position = "0 0 124.143";
			Ocean.baseColor = "43 107 92 0";
			Ocean.hidden = "0";
		]])
		
		targetIndex = 2
		
		scenetree.scenario_player0:queueLuaCommand('electrics.setLightsState(2)')
	end
end

local function onRaceStart()
	flooding = true
end

local function onPreRender(dt)
	if flooding then
	
		local oldTarget = targets[targetIndex - 1]
		local newTarget = targets[targetIndex]
		
		local currentTimeDiff = currentTime - oldTarget.time
		local totalTimeDiff = newTarget.time - oldTarget.time
		local distanceDiff = newTarget.height - oldTarget.height
		
		local currentHeight = oldTarget.height + currentTimeDiff * distanceDiff / totalTimeDiff
		
		currentTime = currentTime + dt
		
		TorqueScript.eval([[
			Ocean.hidden = "1";
			Ocean.setTransform("0 0 ]]..currentHeight..[[ 0 0 1 0");
			Ocean.hidden = "0";
		]])
		
		-- disable flooding if we're lost anyway, to prevent flickering
		local playerHeight = scenetree.scenario_player0:getPosition().z
		
		if playerHeight < currentHeight - 2 then
			flooding = false
		end
		
		if currentTime > newTarget.time then
			if targetIndex == #targets then
				flooding = false
			else
				targetIndex = targetIndex + 1
			end
		end
	end
end

return {
	onPreRender = onPreRender,
	onScenarioChange = onScenarioChange,
	onRaceStart = onRaceStart
}